@echo off

rem
rem To use this in intellij:
rem
rem 1. Add an external tool called idlj
rem    program: $JDKPath$/bin/idlj.exe
rem    parameters: -i $JDKPath$/lib -verbose -pkgPrefix IOP gcc.org.omg -pkgPrefix GIOP gcc.org.omg -pkgPrefix IIOP gcc.org.omg -pkgPrefix CosNaming gcc.org.omg -td $ProjectFileDir$/genfiles/src $FileName$
rem    working directory: $ProjectFileDir$\idl
rem
rem 2. You can right click on the .idl file and choose idlj to build it.
rem

rem
rem This is the good version of the CORBA stubs/skels
rem

setlocal

set pkgprefix=gcc.org.omg

set opts=
set opts=-i %java_home%\lib
set opts=-i ..\idl

rem set opts=%opts% -verbose

set opts=%opts% -pkgPrefix IOP %pkgprefix%
set opts=%opts% -pkgPrefix GIOP %pkgprefix%
set opts=%opts% -pkgPrefix IIOP %pkgprefix%
set opts=%opts% -pkgPrefix CosNaming %pkgprefix%


echo Generating:

echo     IOP.idl
idlj -td src %opts% ..\idl\IOP.idl

echo     GIOP.idl
idlj -td src %opts% ..\idl\GIOP.idl

echo     IIOP.idl
idlj -td src %opts% ..\idl\IIOP.idl

echo     CosNaming.idl
idlj -td src %opts% ..\idl\CosNaming.idl

echo     gcc-rmi-iiop.idl
idlj -td src %opts% ..\idl\gcc-rmi-iiop.idl

endlocal

