/*
 *  Copyright 2004 The Apache Software Foundation or its licensors, as
 *  applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 *  implied.
 *
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package gcc.generator;

import gcc.generator.JBlockStatement;

public class JFinallyStatement extends JStatement
{
    protected JBlockStatement    _finallyStatements;
    protected boolean            _hasStatements = false;

    public JFinallyStatement( )
    {
        _finallyStatements = new JBlockStatement();
    }

    public void addStatement( JStatement s )
    {
        _finallyStatements.addStatement( s );
        _hasStatements = true;
    }

    public JBlockStatement getStatement()
    {
        return _finallyStatements;
    }

    public boolean hasStatements()
    {
        return _hasStatements;
    }
}
