/*
 *  Copyright 2004 The Apache Software Foundation or its licensors, as
 *  applicable.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
 *  implied.
 *
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package gcc.generator;

import java.util.Vector;

public class JForStatement extends JBlockStatement
{
    protected JStatement        _initStmt;
    protected JExpression       _loopExpr;
    protected JStatement        _iterStmt;

    public JForStatement( JStatement init, JExpression loop, JStatement iter )
    {
        super();
        _initStmt = init;
        _loopExpr = loop;
        _iterStmt = iter;
    }

    public JStatement getInitStatement()
    {
        return _initStmt;
    }

    public JExpression getLoopExpression()
    {
        return _loopExpr;
    }

    public JStatement getIterStatement()
    {
        return _iterStmt;
    }
}
