echo on

setlocal

set ejbcp=d:\dev\3rdparty.jag\ejb21\ejb-2_1-api.jar;.\
set testcp=w:\geronimo\corba_container\tests\AddInterface\idl_hand

set cp=%ejbcp%;%testcp%

REM
REM Strange, but idlj will generate org.omg.boxedRMI.xxx_AddData[Helper|Holder] with
REM references to AddData, but in the wrong pacakge, but the org.omg.boxedRMI files
REM will not compile.
REM
REM This was due to the fact that I had AddData and AddInterface in no package.
REM Put them into a package and then things are good.
REM

REM
REM So far so good.  Given an interface the RMIC compiler can generate appropriate IDL for
REM those interfaces.  Don't use non-package java files results in corba stub/skel that have 
REM problems see above.  With value types, it appears as if only the data members are added
REM to the valuetype idl definition.  Later on IDLJ will map the valuetypes to java, but 
REM I had to implement a factory for these classes.  We are not going to generate CORBA
REM stubs for the components anyway so this won't be an issue. IF a client wants to generate 
REM corba stubs for the remote interface and valuetypes, they will need to perform any
REM neccesary extra steps per the client.
REM
REM FOr our client side, we can just directly access the value type class from teh RMI:xxx:0000
REM id and then perform the necessary serialization or externalization on the data from the 
REM stream.
REM

if not "%1" == "" goto %1

:a
rem rmic  -classpath %cp% -keep -idl -noValueMethods mark.AddData
rem rmic  -classpath %cp% -keep -idl -noValueMethods mark.AddInterface
if not "%1" == "" goto end

:b
echo Generating IDLJ for AddInterface.idl
idlj -noWarn -fclient -i %JAVA_HOME%\lib AddInterface.idl
rem idlj -emitAll -verbose -fclient -i %JAVA_HOME%\lib AddInterface.idl
if not "%1" == "" goto end

:c
echo Building IDL Stubs
set cp=%ejbcp%;%testcp%
javac -classpath %cp% -sourcepath %testcp% mark\*.java
javac -classpath %cp% -sourcepath %testcp% org\omg\boxedRMI\mark\*.java
javac -classpath %cp% -sourcepath %testcp% javax\ejb\*.java
javac -classpath %cp% -sourcepath %testcp% *.java
if not "%1" == "" goto end

:end

endlocal
